Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssr.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 3938)
@@ -22,4 +22,5 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE timing          ! Timing
+   USE lib_fortran     ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
 
    IMPLICIT NONE
@@ -174,13 +175,12 @@
                   DO ji = 1, jpi
                      zerp = zsrp * ( 1. - 2.*rnfmsk(ji,jj) )   &      ! No damping in vicinity of river mouths
-                        &        * ( sss_m(ji,jj) - sf_sss(1)%fnow(ji,jj,1) )   &
-                        &        / ( sss_m(ji,jj) + 1.e-20   )
+                        &        * ( sss_m(ji,jj) - sf_sss(1)%fnow(ji,jj,1) )   
                      emps(ji,jj) = emps(ji,jj) + zerp
-                     erp( ji,jj) = zerp
+                     erp (ji,jj) = zerp / MAX( sss_m(ji,jj), 1.e-20 ) ! converted into an equivalent volume flux (diagnostic only)
                   END DO
                END DO
                CALL iom_put( "erp", erp )                             ! freshwater flux damping
                !
-            ELSEIF( nn_sssr == 2 ) THEN               !* Salinity damping term (volume flux, emp and emps)
+            ELSEIF( nn_sssr == 2 ) THEN               !* Salinity damping term (volume flux, emp only)
                zsrp = rn_deds / rday                                  ! from [mm/day] to [kg/m2/s]
                zerp_bnd = rn_sssr_bnd / rday                          !       -              -    
@@ -190,9 +190,8 @@
                      zerp = zsrp * ( 1. - 2.*rnfmsk(ji,jj) )   &      ! No damping in vicinity of river mouths
                         &        * ( sss_m(ji,jj) - sf_sss(1)%fnow(ji,jj,1) )   &
-                        &        / ( sss_m(ji,jj) + 1.e-20   )
+                        &        / MAX(  sss_m(ji,jj), 1.e-20   )
                      IF( ln_sssr_bnd )   zerp = SIGN( 1., zerp ) * MIN( zerp_bnd, ABS(zerp) )
-                     emp (ji,jj) = emp (ji,jj) + zerp
-                     emps(ji,jj) = emps(ji,jj) + zerp
-                     erp (ji,jj) = zerp
+                     emp(ji,jj) = emp (ji,jj) + zerp
+                     erp(ji,jj) = zerp
                   END DO
                END DO
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbctide.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbctide.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbctide.F90	(revision 3938)
@@ -16,4 +16,5 @@
   USE tide_mod
   USE iom
+  USE timing          ! Timing
 
   IMPLICIT NONE
@@ -58,4 +59,5 @@
     NAMELIST/nam_tide/ln_tide_pot,nb_harmo,clname,nn_tide
 
+    IF( nn_timing == 1 )  CALL timing_start('sbctide')
     IF ( kt == nit000 ) THEN
 
@@ -83,4 +85,5 @@
        CALL flush(numout)
     ENDIF
+ 
 
     ALLOCATE(ntide     (nb_harmo))
@@ -113,4 +116,6 @@
     IF (ln_tide_pot          ) CALL tide_init_potential
 
+    IF( nn_timing == 1 )  CALL timing_stop('sbctide')
+    !
   END SUBROUTINE sbc_tide
 
@@ -122,5 +127,4 @@
     INTEGER  :: ji,jj,jk
     REAL(wp) :: zcons,ztmp1,ztmp2,zlat,zlon
-
 
     DO jk=1,nb_harmo
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 3938)
@@ -10,4 +10,5 @@
    !!             -   !  2005-11  (G. Madec) zco, zps, sco coordinate
    !!            3.2  !  2009-04  (G. Madec & NEMO team) 
+   !!            4.0  !  2012-05  (C. Rousset) store attenuation coef for use in ice model 
    !!----------------------------------------------------------------------
 
@@ -44,4 +45,5 @@
    LOGICAL , PUBLIC ::   ln_qsr_2bd = .TRUE.    !: 2 band         light absorption flag
    LOGICAL , PUBLIC ::   ln_qsr_bio = .FALSE.   !: bio-model      light absorption flag
+   LOGICAL , PUBLIC ::   ln_qsr_ice = .TRUE.    !: light penetration for ice-model LIM3 (clem)
    INTEGER , PUBLIC ::   nn_chldta  = 0         !: use Chlorophyll data (=1) or not (=0)
    REAL(wp), PUBLIC ::   rn_abs     = 0.58_wp   !: fraction absorbed in the very near surface (RGB & 2 bands)
@@ -100,4 +102,5 @@
       REAL(wp) ::   zchl, zcoef, zfact   ! local scalars
       REAL(wp) ::   zc0, zc1, zc2, zc3   !    -         -
+      REAL(wp) ::   zzc0, zzc1, zzc2, zzc3   !    -         -
       REAL(wp) ::   zz0, zz1, z1_e3t     !    -         -
       REAL(wp), POINTER, DIMENSION(:,:  ) :: zekb, zekg, zekr
@@ -159,4 +162,15 @@
          END DO
          CALL iom_put( 'qsr3d', etot3 )   ! Shortwave Radiation 3D distribution
+         ! clem: store attenuation coefficient of the first ocean level
+         IF ( ln_qsr_ice ) THEN
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  IF ( qsr(ji,jj) /= 0._wp ) THEN
+                     oatte(ji,jj) = ( qsr_hc(ji,jj,1) / ( ro0cpr * qsr(ji,jj) ) )
+                     iatte(ji,jj) = oatte(ji,jj)
+                  ENDIF
+               END DO
+            END DO
+         ENDIF
          !                                        ! ============================================== !
       ELSE                                        !  Ocean alone : 
@@ -217,4 +231,17 @@
                   END DO
                END DO
+               ! clem: store attenuation coefficient of the first ocean level
+               IF ( ln_qsr_ice ) THEN
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi
+                        zzc0 = rn_abs * EXP( - fse3t(ji,jj,1) * xsi0r     )
+                        zzc1 = zcoef  * EXP( - fse3t(ji,jj,1) * zekb(ji,jj) )
+                        zzc2 = zcoef  * EXP( - fse3t(ji,jj,1) * zekg(ji,jj) )
+                        zzc3 = zcoef  * EXP( - fse3t(ji,jj,1) * zekr(ji,jj) )
+                        oatte(ji,jj) = ( 1.0 - ( zzc0 + zzc1 + zzc2  + zzc3  ) ) * tmask(ji,jj,2) 
+                        iatte(ji,jj) = ( 1.0 - ( zzc0 + zzc1 + zcoef + zcoef ) ) * tmask(ji,jj,2)
+                     END DO
+                  END DO
+               ENDIF
                !
                DO jk = 1, nksr                                        ! compute and add qsr trend to ta
@@ -228,5 +255,10 @@
                   qsr_hc(:,:,jk) =  etot3(:,:,jk) * qsr(:,:)
                END DO
-            ENDIF
+               ! clem: store attenuation coefficient of the first ocean level
+               IF ( ln_qsr_ice ) THEN
+                  oatte(:,:) = etot3(:,:,1) / ro0cpr
+                  iatte(:,:) = oatte(:,:)
+               ENDIF
+           ENDIF
 
          ENDIF
@@ -247,4 +279,15 @@
                   END DO
                END DO
+               ! clem: store attenuation coefficient of the first ocean level
+               IF ( ln_qsr_ice ) THEN
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi
+                        zc0 = zz0 * EXP( -fsdepw(ji,jj,1)*xsi0r ) + zz1 * EXP( -fsdepw(ji,jj,1)*xsi1r )
+                        zc1 = zz0 * EXP( -fsdepw(ji,jj,2)*xsi0r ) + zz1 * EXP( -fsdepw(ji,jj,2)*xsi1r )
+                        oatte(ji,jj) = ( zc0*tmask(ji,jj,1) - zc1*tmask(ji,jj,2) ) / ro0cpr
+                        iatte(ji,jj) = oatte(ji,jj)
+                     END DO
+                  END DO
+               ENDIF
             ELSE                                               !* constant volume: coef. computed one for all
                DO jk = 1, nksr
@@ -255,4 +298,9 @@
                   END DO
                END DO
+               ! clem: store attenuation coefficient of the first ocean level
+               IF ( ln_qsr_ice ) THEN
+                  oatte(:,:) = etot3(:,:,1) / ro0cpr
+                  iatte(:,:) = oatte(:,:)
+               ENDIF
                !
             ENDIF
@@ -271,4 +319,15 @@
          !
       ENDIF
+      ! clem: store attenuation coefficient of the first ocean level
+      !IF (ln_traqsr) THEN
+      !   DO jj = 1, jpj
+      !      DO ji = 1, jpi
+      !         IF ( qsr(ji,jj) /= 0._wp ) THEN
+      !            oatte(ji,jj) = qsr_hc(ji,jj,1) / ( ro0cpr * qsr(ji,jj) )
+      !            iatte(ji,jj) = qsr_hc(ji,jj,1) / ( ro0cpr * qsr(ji,jj) )
+      !         ENDIF
+      !      END DO
+      !   END DO
+      !END IF
       !
       IF( lrst_oce ) THEN   !                  Write in the ocean restart file
@@ -279,5 +338,4 @@
          IF(lwp) WRITE(numout,*) '~~~~'
          CALL iom_rstput( kt, nitrst, numrow, 'qsr_hc_b', qsr_hc )
-         !
       ENDIF
 
@@ -326,5 +384,5 @@
       TYPE(FLD_N)        ::   sn_chl   ! informations about the chlorofyl field to be read
       !!
-      NAMELIST/namtra_qsr/  sn_chl, cn_dir, ln_traqsr, ln_qsr_rgb, ln_qsr_2bd, ln_qsr_bio,   &
+      NAMELIST/namtra_qsr/  sn_chl, cn_dir, ln_traqsr, ln_qsr_rgb, ln_qsr_2bd, ln_qsr_bio, ln_qsr_ice,  &
          &                  nn_chldta, rn_abs, rn_si0, rn_si1
       !!----------------------------------------------------------------------
@@ -333,8 +391,11 @@
       IF( nn_timing == 1 )  CALL timing_start('tra_qsr_init')
       !
+      ! clem init for oatte and iatte
+      oatte(:,:) = 1._wp
+      iatte(:,:) = 1._wp
+      !
       CALL wrk_alloc( jpi, jpj,      zekb, zekg, zekr        ) 
       CALL wrk_alloc( jpi, jpj, jpk, ze0, ze1, ze2, ze3, zea ) 
       !
-
       cn_dir = './'       ! directory in which the model is executed
       ! ... default values (NB: frequency positive => hours, negative => months)
@@ -355,4 +416,5 @@
          WRITE(numout,*) '      2 band               light penetration   ln_qsr_2bd = ', ln_qsr_2bd
          WRITE(numout,*) '      bio-model            light penetration   ln_qsr_bio = ', ln_qsr_bio
+         WRITE(numout,*) '      light penetration for ice-model LIM3     ln_qsr_ice = ', ln_qsr_ice
          WRITE(numout,*) '      RGB : Chl data (=1) or cst value (=0)    nn_chldta  = ', nn_chldta
          WRITE(numout,*) '      RGB & 2 bands: fraction of light (rn_si1)    rn_abs = ', rn_abs
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/TRA/trasbc.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 3938)
@@ -169,5 +169,6 @@
                sbc_tsc(ji,jj,jp_tem) = ro0cpr * qns(ji,jj) - zsrau * emp(ji,jj) * tsn(ji,jj,1,jp_tem)
                ! concent./dilut. effect due to sea-ice melt/formation and (possibly) SSS restoration
-               sbc_tsc(ji,jj,jp_sal) = ( emps(ji,jj) - emp(ji,jj) ) * zsrau * tsn(ji,jj,1,jp_sal)
+               !sbc_tsc(ji,jj,jp_sal) = ( emps(ji,jj) - emp(ji,jj) ) * zsrau * tsn(ji,jj,1,jp_sal)
+               sbc_tsc(ji,jj,jp_sal) = emps(ji,jj) * zsrau  ! IOVINO + CLEM
             END DO
          END DO
@@ -178,5 +179,9 @@
                sbc_tsc(ji,jj,jp_tem) = ro0cpr * qns(ji,jj)
                ! salinity    : salt flux + concent./dilut. effect (both in emps)
-               sbc_tsc(ji,jj,jp_sal) = zsrau * emps(ji,jj) * tsn(ji,jj,1,jp_sal)
+#if defined key_lim3
+               sbc_tsc(ji,jj,jp_sal) = zsrau * emps(ji,jj) + zsrau * emp(ji,jj) * tsn(ji,jj,1,jp_sal) ! IOVINO
+#else
+               sbc_tsc(ji,jj,jp_sal) = zsrau * emps(ji,jj) * tsn(ji,jj,1,jp_sal) ! regular expression
+#endif
             END DO
          END DO
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/step.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 3938)
@@ -234,7 +234,8 @@
                                CALL ssh_nxt( kstp )         ! sea surface height at next time step
 
-      IF( ln_diahsb        )   CALL dia_hsb( kstp )         ! - ML - global conservation diagnostics
+      IF( ln_diahsb        )   CALL dia_hsb( kstp )         ! global conservation diagnostics
       IF( lk_diaobs  )         CALL dia_obs( kstp )         ! obs-minus-model (assimilation) diagnostics (call after dynamics update)
 
+      IF( lrst_oce .AND. ln_diahsb )   CALL dia_hsb_rst( kstp, 'WRITE' )
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
       ! Control and restarts
